//+------------------------------------------------------------------+
//|                                             Vscr_SaveHistory.mq4 |
//|                                       Copyright  2006, Vitaurus |
//|                                               vitaurus@yandex.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, forexexp"
#property link      "http://vitaurus.narod.ru"
#property show_inputs
#include <stdlib.mqh>

extern string FileName="For_Vitaurus"; //      

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
{
int handle,BeginPos,EndPos;
string Name;
datetime _CurrRed, _FirstRed=Time[0], _LastBlue, _CurrBlue;
bool _Red=false, _Blue=false;
   FileName=FileName+"_"+Symbol()+Period()+".csv";
   handle=FileOpen(FileName,FILE_CSV|FILE_WRITE,',');
   if(handle<1) Print("   ",FileName," ",ErrorDescription(GetLastError())); 
   for(int cnt=ObjectsTotal()-1;cnt>=0;cnt--)
   {
      Name=ObjectName(cnt);
      if(ObjectType(Name)==OBJ_VLINE)
      {
         if(ObjectGet(Name,OBJPROP_COLOR)==Red)
         {
            _CurrRed=ObjectGet( Name,OBJPROP_TIME1);
            _Red=true;
            if(_CurrRed<_FirstRed) _FirstRed=_CurrRed;
         } 
         if(ObjectGet( Name,OBJPROP_COLOR)==Blue)
         {
            _Blue=true;
            _CurrBlue=ObjectGet( Name,OBJPROP_TIME1);
            if(_CurrBlue>_LastBlue) _LastBlue=_CurrBlue;
         } 
      }
   }
   if(!_Red)
   {
      Alert("     ");
      return(0);
   }
   if(!_Blue)
   {
      Alert("     ");
      return(0);
   }
   if(_LastBlue<_FirstRed)
   {
      Alert("      ");
      return(0);
   }
   BeginPos =iBarShift(NULL,0,_FirstRed);
   EndPos   =iBarShift(NULL,0,_LastBlue);
   for(int i=BeginPos;i>=EndPos;i--)
   {
      if(FileWrite(handle,TimeToStr(Time[i],TIME_DATE),TimeToStr(Time[i],TIME_MINUTES),Open[i],High[i],Low[i],Close[i],Volume[i])<0)
         Print("    ",FileName," ",ErrorDescription(GetLastError())); 
   }
   FileFlush(handle);
   FileClose(handle);
   Alert (" ",BeginPos-EndPos," ()");
   return(0);
}
//+------------------------------------------------------------------+